package org.apache.bcel.generic;

import org.apache.bcel.ExceptionConst;
import org.apache.bcel.ExceptionConst.EXCS;

public class CHECKCAST extends CPInstruction implements LoadClass, ExceptionThrower, StackProducer, StackConsumer {
   CHECKCAST() {
   }

   public CHECKCAST(int index) {
      super((short)192, index);
   }

   public void accept(Visitor v) {
      v.visitLoadClass(this);
      v.visitExceptionThrower(this);
      v.visitStackProducer(this);
      v.visitStackConsumer(this);
      v.visitTypedInstruction(this);
      v.visitCPInstruction(this);
      v.visitCHECKCAST(this);
   }

   public Class<?>[] getExceptions() {
      return ExceptionConst.createExceptions(EXCS.EXCS_CLASS_AND_INTERFACE_RESOLUTION, new Class[]{ExceptionConst.CLASS_CAST_EXCEPTION});
   }

   public ObjectType getLoadClassType(ConstantPoolGen cpg) {
      Type t = this.getType(cpg);
      if (t instanceof ArrayType) {
         t = ((ArrayType)t).getBasicType();
      }

      return t instanceof ObjectType ? (ObjectType)t : null;
   }
}
